/***************************************************************************
 *   Copyright (C) 2014 by Abderrahman Taha                                *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA            *
 ***************************************************************************/

#include <iostream>
#include <string.h>
#include <cmath>
#include  "../../fparser/fparser.h"
#include "../objectparameters.h"






/*


                     4.-----------4----------------.5
                     /|                                     /|
                    7 |                                 5 |
                   /  |                                  /  |
                 7.---|-----------6------------.6  |
                  |   |                                 |   |
                  |   8                               |   9
                  |   |                                 |   |
                  |   ^ j                               |   |
               11   |                               10   |
                  |   |     i                           |   |
                  |  0.----->-----0------------|---.1
                  |  /                                  |  /
                  | 3 k                               | 1
                  |/                                    |/
                 3.---------------2------------.2
*/
struct ImplicitStruct
{
    std::string fxyz;
    std::string xmin;
    std::string xmax;
    std::string ymin;
    std::string ymax;
    std::string zmin;
    std::string zmax;
    std::string grid;
    std::string cnd;
    int              index;
};

struct  Voxel
{
    int Edge_Points [12]; //reference to the Edge Points
    int Signature; // From 0 to 255
    int NbEdgePoint;
};

class Iso3D
{
public :
    int   *     IsoSurfaceTriangleListe;
    bool *     WichPointVerifyCond;
    int *     TypeIsoSurfaceTriangleListeCND;
    float *     NormVertexTab;
    unsigned int *  IndexPolyTab;
    double IsoNormOriginal[2*3*1];
    double AxeArrayOriginal[3][500];  // 3D Axes X, y and Z with 50 points

    int MaximumNumberPoints, MaximumNumberTriangles,MaximumNumberTrianglesMin;
    int NbPointIsoMap;
    int NbTriangleIsoSurface, IsoConditionRequired,NbPointIsoMapCND,
        ThreeTimesNbPolygnTmp;
    int i,j,k,l;

    FunctionParser implicitFunctionParser[100],IsoConditionParser[100],
                   xSupParser[100], xInfParser[100],
                   ySupParser[100], yInfParser[100],
                   zSupParser[100], zInfParser[100],
                   Var[10], Fct[10],Cstparser;
    std::string ImplicitFunction, Condition,
        XlimitSup, XlimitInf,
        YlimitSup, YlimitInf,
        ZlimitSup, ZlimitInf, Grid,
        Const, Consts[10], ConstNames[10],
        Varu, Varus[10], VarName[10],
        Funct, Functs[10], FunctNames[10];
    double ConstValues[10];

    ImplicitStruct ImplicitStructs[100];
    int GridTable[100];
    int Nb_implicitfunctions, Nb_newvariables, Nb_constants, Nb_functs;
    double stepMorph, pace;
    int morph_activated;
    bool AllComponentTraited;
    double X_Start, X_End, X_Step,
           Y_Start, Y_End, Y_Step,
           Z_Start, Z_End, Z_Step;
    double x_Step[100], y_Step[100], z_Step[100];
    int   nb_ligne, nb_colon, nb_depth,
          CutLigne, CutColon, CutDepth;

    int  IsoMesh, IsoInfos, NbTriangleUsed, hauteur_fenetre;
    double xLocal[50][500], yLocal[50][500], zLocal[50][500];

    double  vr[30][50][500];//30-> because we have 10 varu and each can be used for x,y or z
    //50-> the max isosurface to calculate;
    // 500-> the maximum grid supported (for now)
    int NbPolygonImposedLimit ;
    int NbVertex;
    unsigned int NbPolygn;
    unsigned int NbPolygnNbVertex[2];

public :
    Iso3D();
    ~Iso3D();
    inline   void VoxelEvaluation(int);
    inline   void PointEdgeComputation(int);
    inline   void DrawIsoSurface();
    inline   void InitParser();
    inline   void InitParameter();
    inline   void SignatureComputation();
    inline   void ConstructIsoSurface();
    inline void ConstructIsoNormale();
    inline void ParseExpression(std::string);
    inline void EvalExpressionAtIndex(int);
    void MinimalMeshObjFile();
    inline void CNDCalculation(int, struct ComponentInfos *);
/// FOR GL Window :
    void ParserIso();
    void IsoBuild(float *, unsigned int *, unsigned int *,unsigned  int *, unsigned int * a=NULL,unsigned  int *b=NULL, ComponentInfos *components = NULL, int *listeCND=NULL);
    void SaveIsoGLMap();
    int  setmaxgridto(int);
    void SetMinimuMmeshSize(double);
    void SetMiniMmeshStruct();
    void stopcalculations();
    int HowManyIsosurface(std::string,int);
    int HowManyVariables(std::string, int);
};
